From 8d06f5b588e28524e89a1a8708e8ef4decd3854e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 02:17:42 +0000
Subject: [PATCH 464/2232] Remove CxxVector::push_back for now


I'd like to give some more thought to how to expose this. Taking the
value by reference and copying it into the vector is nice when T is an
opaque C++ type but otherwise a pretty weird API from Rust.

---

diff --git a/gen/write.rs b/gen/write.rs
index cdbfc75..b39d978 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -1217,13 +1217,6 @@ fn write_cxx_vector(out: &mut OutFile, vector_ty: &Type, element: &Ident, types:
     );
     writeln!(out, "  return s[pos];");
     writeln!(out, "}}");
-    writeln!(
-        out,
-        "void cxxbridge02$std$vector${}$push_back(::std::vector<{}> &s, const {} &item) noexcept {{",
-        instance, inner, inner
-    );
-    writeln!(out, "  s.push_back(item);");
-    writeln!(out, "}}");
 
     write_unique_ptr_common(out, vector_ty, types);
 
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index c404e00..27d75fe 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -668,7 +668,6 @@ fn expand_cxx_vector(namespace: &Namespace, elem: &Ident) -> TokenStream {
     let prefix = format!("cxxbridge02$std$vector${}{}$", namespace, elem);
     let link_size = format!("{}size", prefix);
     let link_get_unchecked = format!("{}get_unchecked", prefix);
-    let link_push_back = format!("{}push_back", prefix);
     let unique_ptr_prefix = format!("cxxbridge02$unique_ptr$std$vector${}{}$", namespace, elem);
     let link_unique_ptr_null = format!("{}null", unique_ptr_prefix);
     let link_unique_ptr_raw = format!("{}raw", unique_ptr_prefix);
@@ -693,13 +692,6 @@ fn expand_cxx_vector(namespace: &Namespace, elem: &Ident) -> TokenStream {
                 }
                 &*__get_unchecked(v, pos)
             }
-            fn __push_back(v: &mut ::cxx::CxxVector<Self>, item: &Self) {
-                extern "C" {
-                    #[link_name = #link_push_back]
-                    fn __push_back(_: &mut ::cxx::CxxVector<#elem>, _: &#elem);
-                }
-                unsafe { __push_back(v, item) }
-            }
             fn __unique_ptr_null() -> *mut ::std::ffi::c_void {
                 extern "C" {
                     #[link_name = #link_unique_ptr_null]
diff --git a/src/cxx.cc b/src/cxx.cc
index 0ead3f0..8409772 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -208,10 +208,6 @@ void cxxbridge02$unique_ptr$std$string$drop(
       const std::vector<CXX_TYPE> &s, size_t pos) noexcept {                   \
     return &s[pos];                                                            \
   }                                                                            \
-  void cxxbridge02$std$vector$##RUST_TYPE##$push_back(                         \
-      std::vector<CXX_TYPE> &s, const CXX_TYPE &item) noexcept {               \
-    s.push_back(item);                                                         \
-  }                                                                            \
   void cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$null(                   \
       std::unique_ptr<std::vector<CXX_TYPE>> *ptr) noexcept {                  \
     new (ptr) std::unique_ptr<std::vector<CXX_TYPE>>();                        \
diff --git a/src/cxx_vector.rs b/src/cxx_vector.rs
index 77e7af1..695fcad 100644
--- a/src/cxx_vector.rs
+++ b/src/cxx_vector.rs
@@ -62,11 +62,6 @@ where
     pub unsafe fn get_unchecked(&self, pos: usize) -> &T {
         T::__get_unchecked(self, pos)
     }
-
-    /// Appends an element to the back of the vector.
-    pub fn push_back(&mut self, item: &T) {
-        T::__push_back(self, item);
-    }
 }
 
 pub struct Iter<'a, T> {
@@ -126,7 +121,6 @@ pub unsafe trait VectorElement: Sized {
     const __NAME: &'static dyn Display;
     fn __vector_size(v: &CxxVector<Self>) -> usize;
     unsafe fn __get_unchecked(v: &CxxVector<Self>, pos: usize) -> &Self;
-    fn __push_back(v: &mut CxxVector<Self>, item: &Self);
     fn __unique_ptr_null() -> *mut c_void;
     unsafe fn __unique_ptr_raw(raw: *mut CxxVector<Self>) -> *mut c_void;
     unsafe fn __unique_ptr_get(repr: *mut c_void) -> *const CxxVector<Self>;
@@ -158,15 +152,6 @@ macro_rules! impl_vector_element_for_primitive {
                 }
                 &*__get_unchecked(v, pos)
             }
-            fn __push_back(v: &mut CxxVector<$ty>, item: &$ty) {
-                extern "C" {
-                    attr! {
-                        #[link_name = concat!("cxxbridge02$std$vector$", stringify!($ty), "$push_back")]
-                        fn __push_back(_: &mut CxxVector<$ty>, _: &$ty);
-                    }
-                }
-                unsafe { __push_back(v, item) }
-            }
             fn __unique_ptr_null() -> *mut c_void {
                 extern "C" {
                     attr! {

